=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2009-06-27 18:59:16 +0000
+++ drizzled/definitions.h	2009-06-29 17:24:02 +0000
@@ -784,31 +784,6 @@
 
 enum enum_duplicates { DUP_ERROR, DUP_REPLACE, DUP_UPDATE };
 
-/*
-  Make sure that the order of schema_tables and enum_schema_tables are the same.
-*/
-
-enum enum_schema_tables
-{
-  SCH_COLUMNS= 0,
-  SCH_GLOBAL_STATUS,
-  SCH_GLOBAL_VARIABLES,
-  SCH_KEY_COLUMN_USAGE,
-  SCH_OPEN_TABLES,
-  SCH_PLUGINS,
-  SCH_REFERENTIAL_CONSTRAINTS,
-  SCH_SCHEMATA,
-  SCH_SESSION_STATUS,
-  SCH_SESSION_VARIABLES,
-  SCH_STATISTICS,
-  SCH_STATUS,
-  SCH_TABLES,
-  SCH_TABLE_CONSTRAINTS,
-  SCH_TABLE_NAMES,
-  SCH_VARIABLES
-};
-
-
 #define MY_I_S_MAYBE_NULL 1
 #define MY_I_S_UNSIGNED   2
 

=== modified file 'drizzled/info_schema.h'
--- drizzled/info_schema.h	2009-06-27 18:59:16 +0000
+++ drizzled/info_schema.h	2009-06-29 16:05:47 +0000
@@ -221,14 +221,6 @@
                         COND *cond);
 };
 
-class KeyColUsageISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int processTable(Session *session, TableList *tables,
-                           Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
-};
-
 class OpenTablesISMethods : public InfoSchemaMethods
 {
 public:
@@ -237,22 +229,6 @@
                         COND *cond);
 };
 
-class PluginsISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int fillTable(Session *session, 
-                        TableList *tables,
-                        COND *cond);
-};
-
-class RefConstraintsISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int processTable(Session *session, TableList *tables,
-                           Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
-};
-
 class SchemataISMethods : public InfoSchemaMethods
 {
 public:
@@ -278,14 +254,6 @@
                            LEX_STRING *table_name) const;
 };
 
-class TabConstraintsISMethods : public InfoSchemaMethods
-{
-public:
-  virtual int processTable(Session *session, TableList *tables,
-                           Table *table, bool res, LEX_STRING *db_name,
-                           LEX_STRING *table_name) const;
-};
-
 class TabNamesISMethods : public InfoSchemaMethods
 {
 public:

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-06-27 18:59:16 +0000
+++ drizzled/show.cc	2009-06-29 17:24:02 +0000
@@ -137,92 +137,6 @@
 ** List all table types supported
 ***************************************************************************/
 
-class ShowPlugins : public unary_function<st_plugin_int *, bool>
-{
-  Session *session;
-  Table *table;
-public:
-  ShowPlugins(Session *session_arg, Table *table_arg)
-    : session(session_arg), table(table_arg) {}
-
-  result_type operator() (argument_type plugin)
-  {
-    struct drizzled_plugin_manifest *plug= plugin_decl(plugin);
-    const CHARSET_INFO * const cs= system_charset_info;
-  
-    table->restoreRecordAsDefault();
-  
-    table->field[0]->store(plugin_name(plugin)->str,
-                           plugin_name(plugin)->length, cs);
-  
-    if (plug->version)
-    {
-      table->field[1]->store(plug->version, strlen(plug->version), cs);
-      table->field[1]->set_notnull();
-    }
-    else
-      table->field[1]->set_null();
-  
-    if (plugin->isInited)
-      table->field[2]->store(STRING_WITH_LEN("ACTIVE"), cs);
-    else
-      table->field[2]->store(STRING_WITH_LEN("INACTIVE"), cs);
-  
-    if (plug->author)
-    {
-      table->field[3]->store(plug->author, strlen(plug->author), cs);
-      table->field[3]->set_notnull();
-    }
-    else
-      table->field[3]->set_null();
-  
-    if (plug->descr)
-    {
-      table->field[4]->store(plug->descr, strlen(plug->descr), cs);
-      table->field[4]->set_notnull();
-    }
-    else
-      table->field[4]->set_null();
-  
-    switch (plug->license) {
-    case PLUGIN_LICENSE_GPL:
-      table->field[5]->store(PLUGIN_LICENSE_GPL_STRING,
-                             strlen(PLUGIN_LICENSE_GPL_STRING), cs);
-      break;
-    case PLUGIN_LICENSE_BSD:
-      table->field[5]->store(PLUGIN_LICENSE_BSD_STRING,
-                             strlen(PLUGIN_LICENSE_BSD_STRING), cs);
-      break;
-    case PLUGIN_LICENSE_LGPL:
-      table->field[5]->store(PLUGIN_LICENSE_LGPL_STRING,
-                             strlen(PLUGIN_LICENSE_LGPL_STRING), cs);
-      break;
-    default:
-      table->field[5]->store(PLUGIN_LICENSE_PROPRIETARY_STRING,
-                             strlen(PLUGIN_LICENSE_PROPRIETARY_STRING), cs);
-      break;
-    }
-    table->field[5]->set_notnull();
-  
-    return schema_table_store_record(session, table);
-  }
-};
-
-
-int PluginsISMethods::fillTable(Session *session, TableList *tables, COND *)
-{
-  Table *table= tables->table;
-
-  PluginRegistry &registry= PluginRegistry::getPluginRegistry();
-  vector<st_plugin_int *> plugins= registry.get_list(true);
-  vector<st_plugin_int *>::iterator iter=
-    find_if(plugins.begin(), plugins.end(), ShowPlugins(session, table));
-  if (iter != plugins.end())
-    return 1;
-  return(0);
-}
-
-
 /*
   find_files() - find files in a given directory.
 
@@ -1773,12 +1687,6 @@
 }
 
 
-enum enum_schema_tables get_schema_table_idx(InfoSchemaTable *schema_table)
-{
-  return (enum enum_schema_tables) (schema_table - &schema_tables[0]);
-}
-
-
 /*
   Create db names list. Information schema name always is first in list
 
@@ -2261,7 +2169,6 @@
   LOOKUP_FIELD_VALUES lookup_field_vals;
   LEX_STRING *db_name, *table_name;
   bool with_i_schema;
-  enum enum_schema_tables schema_table_idx;
   List<LEX_STRING> db_names;
   List_iterator_fast<LEX_STRING> it(db_names);
   COND *partial_cond= 0;
@@ -2279,7 +2186,6 @@
   */
   session->reset_n_backup_open_tables_state(&open_tables_state_backup);
 
-  schema_table_idx= get_schema_table_idx(schema_table);
   tables->table_open_method= table_open_method=
     get_table_open_method(tables, schema_table);
   /*
@@ -2366,8 +2272,9 @@
             table name or lookup value is wild string(table name list is
             already created by make_table_name_list() function).
           */
-          if (!table_open_method && schema_table_idx == SCH_TABLES &&
-              (!lookup_field_vals.table_value.length ||
+          if (! table_open_method &&
+              schema_table->getTableName().compare("TABLES") == 0 &&
+              (! lookup_field_vals.table_value.length ||
                lookup_field_vals.wild_table_value))
           {
             if (schema_table_store_record(session, table))
@@ -2376,7 +2283,7 @@
           }
 
           /* SHOW Table NAMES command */
-          if (schema_table_idx == SCH_TABLE_NAMES)
+          if (schema_table->getTableName().compare("TABLE_NAMES") == 0)
           {
             if (fill_schema_table_names(session, tables->table, db_name,
                                         table_name, with_i_schema))
@@ -3053,184 +2960,6 @@
 }
 
 
-bool store_constraints(Session *session, Table *table, LEX_STRING *db_name,
-                       LEX_STRING *table_name, const char *key_name,
-                       uint32_t key_len, const char *con_type, uint32_t con_len)
-{
-  const CHARSET_INFO * const cs= system_charset_info;
-  table->restoreRecordAsDefault();
-  table->field[1]->store(db_name->str, db_name->length, cs);
-  table->field[2]->store(key_name, key_len, cs);
-  table->field[3]->store(db_name->str, db_name->length, cs);
-  table->field[4]->store(table_name->str, table_name->length, cs);
-  table->field[5]->store(con_type, con_len, cs);
-  return schema_table_store_record(session, table);
-}
-
-
-int TabConstraintsISMethods::processTable(Session *session, TableList *tables,
-					 Table *table, bool res,
-					 LEX_STRING *db_name,
-					 LEX_STRING *table_name) const
-{
-  if (res)
-  {
-    if (session->is_error())
-      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                   session->main_da.sql_errno(), session->main_da.message());
-    session->clear_error();
-    return(0);
-  }
-  else
-  {
-    List<FOREIGN_KEY_INFO> f_key_list;
-    Table *show_table= tables->table;
-    KEY *key_info=show_table->key_info;
-    uint32_t primary_key= show_table->s->primary_key;
-    show_table->file->info(HA_STATUS_VARIABLE |
-                           HA_STATUS_NO_LOCK |
-                           HA_STATUS_TIME);
-    for (uint32_t i=0 ; i < show_table->s->keys ; i++, key_info++)
-    {
-      if (i != primary_key && !(key_info->flags & HA_NOSAME))
-        continue;
-
-      if (i == primary_key && is_primary_key(key_info))
-      {
-        if (store_constraints(session, table, db_name, table_name, key_info->name,
-                              strlen(key_info->name),
-                              STRING_WITH_LEN("PRIMARY KEY")))
-          return(1);
-      }
-      else if (key_info->flags & HA_NOSAME)
-      {
-        if (store_constraints(session, table, db_name, table_name, key_info->name,
-                              strlen(key_info->name),
-                              STRING_WITH_LEN("UNIQUE")))
-          return(1);
-      }
-    }
-
-    show_table->file->get_foreign_key_list(session, &f_key_list);
-    FOREIGN_KEY_INFO *f_key_info;
-    List_iterator_fast<FOREIGN_KEY_INFO> it(f_key_list);
-    while ((f_key_info=it++))
-    {
-      if (store_constraints(session, table, db_name, table_name,
-                            f_key_info->forein_id->str,
-                            strlen(f_key_info->forein_id->str),
-                            "FOREIGN KEY", 11))
-        return(1);
-    }
-  }
-  return(res);
-}
-
-
-void store_key_column_usage(Table *table, LEX_STRING *db_name,
-                            LEX_STRING *table_name, const char *key_name,
-                            uint32_t key_len, const char *con_type, uint32_t con_len,
-                            int64_t idx)
-{
-  const CHARSET_INFO * const cs= system_charset_info;
-  table->field[1]->store(db_name->str, db_name->length, cs);
-  table->field[2]->store(key_name, key_len, cs);
-  table->field[4]->store(db_name->str, db_name->length, cs);
-  table->field[5]->store(table_name->str, table_name->length, cs);
-  table->field[6]->store(con_type, con_len, cs);
-  table->field[7]->store((int64_t) idx, true);
-}
-
-
-int KeyColUsageISMethods::processTable(Session *session,
-					      TableList *tables,
-					      Table *table, bool res,
-					      LEX_STRING *db_name,
-					      LEX_STRING *table_name) const
-{
-  if (res)
-  {
-    if (session->is_error())
-      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                   session->main_da.sql_errno(), session->main_da.message());
-    session->clear_error();
-    return(0);
-  }
-  else
-  {
-    List<FOREIGN_KEY_INFO> f_key_list;
-    Table *show_table= tables->table;
-    KEY *key_info=show_table->key_info;
-    uint32_t primary_key= show_table->s->primary_key;
-    show_table->file->info(HA_STATUS_VARIABLE |
-                           HA_STATUS_NO_LOCK |
-                           HA_STATUS_TIME);
-    for (uint32_t i=0 ; i < show_table->s->keys ; i++, key_info++)
-    {
-      if (i != primary_key && !(key_info->flags & HA_NOSAME))
-        continue;
-      uint32_t f_idx= 0;
-      KEY_PART_INFO *key_part= key_info->key_part;
-      for (uint32_t j=0 ; j < key_info->key_parts ; j++,key_part++)
-      {
-        if (key_part->field)
-        {
-          f_idx++;
-          table->restoreRecordAsDefault();
-          store_key_column_usage(table, db_name, table_name,
-                                 key_info->name,
-                                 strlen(key_info->name),
-                                 key_part->field->field_name,
-                                 strlen(key_part->field->field_name),
-                                 (int64_t) f_idx);
-          if (schema_table_store_record(session, table))
-            return(1);
-        }
-      }
-    }
-
-    show_table->file->get_foreign_key_list(session, &f_key_list);
-    FOREIGN_KEY_INFO *f_key_info;
-    List_iterator_fast<FOREIGN_KEY_INFO> fkey_it(f_key_list);
-    while ((f_key_info= fkey_it++))
-    {
-      LEX_STRING *f_info;
-      LEX_STRING *r_info;
-      List_iterator_fast<LEX_STRING> it(f_key_info->foreign_fields),
-        it1(f_key_info->referenced_fields);
-      uint32_t f_idx= 0;
-      while ((f_info= it++))
-      {
-        r_info= it1++;
-        f_idx++;
-        table->restoreRecordAsDefault();
-        store_key_column_usage(table, db_name, table_name,
-                               f_key_info->forein_id->str,
-                               f_key_info->forein_id->length,
-                               f_info->str, f_info->length,
-                               (int64_t) f_idx);
-        table->field[8]->store((int64_t) f_idx, true);
-        table->field[8]->set_notnull();
-        table->field[9]->store(f_key_info->referenced_db->str,
-                               f_key_info->referenced_db->length,
-                               system_charset_info);
-        table->field[9]->set_notnull();
-        table->field[10]->store(f_key_info->referenced_table->str,
-                                f_key_info->referenced_table->length,
-                                system_charset_info);
-        table->field[10]->set_notnull();
-        table->field[11]->store(r_info->str, r_info->length,
-                                system_charset_info);
-        table->field[11]->set_notnull();
-        if (schema_table_store_record(session, table))
-          return(1);
-      }
-    }
-  }
-  return(res);
-}
-
-
 int OpenTablesISMethods::fillTable(Session *session, TableList *tables, COND *)
 {
   const char *wild= session->lex->wild ? session->lex->wild->ptr() : NULL;
@@ -3260,15 +2989,16 @@
   int res= 0;
   LEX *lex= session->lex;
   const char *wild= lex->wild ? lex->wild->ptr() : NULL;
-  enum enum_schema_tables schema_table_idx=
-    get_schema_table_idx(tables->schema_table);
+  const string schema_table_name= tables->schema_table->getTableName();
   enum enum_var_type option_type= OPT_SESSION;
-  bool upper_case_names= (schema_table_idx != SCH_VARIABLES);
-  bool sorted_vars= (schema_table_idx == SCH_VARIABLES);
+  bool upper_case_names= (schema_table_name.compare("VARIABLES") != 0);
+  bool sorted_vars= (schema_table_name.compare("VARIABLES") == 0);
 
   if (lex->option_type == OPT_GLOBAL ||
-      schema_table_idx == SCH_GLOBAL_VARIABLES)
+      schema_table_name.compare("GLOBAL_VARIABLES") == 0)
+  {
     option_type= OPT_GLOBAL;
+  }
 
   pthread_rwlock_rdlock(&LOCK_system_variables_hash);
   res= show_status_array(session, wild, enumerate_sys_vars(session, sorted_vars),
@@ -3284,12 +3014,11 @@
   const char *wild= lex->wild ? lex->wild->ptr() : NULL;
   int res= 0;
   STATUS_VAR *tmp1, tmp;
-  enum enum_schema_tables schema_table_idx=
-    get_schema_table_idx(tables->schema_table);
+  const string schema_table_name= tables->schema_table->getTableName();
   enum enum_var_type option_type;
-  bool upper_case_names= (schema_table_idx != SCH_STATUS);
+  bool upper_case_names= (schema_table_name.compare("STATUS") != 0);
 
-  if (schema_table_idx == SCH_STATUS)
+  if (schema_table_name.compare("STATUS") == 0)
   {
     option_type= lex->option_type;
     if (option_type == OPT_GLOBAL)
@@ -3297,7 +3026,7 @@
     else
       tmp1= session->initial_status_var;
   }
-  else if (schema_table_idx == SCH_GLOBAL_STATUS)
+  else if (schema_table_name.compare("GLOBAL_STATUS") == 0)
   {
     option_type= OPT_GLOBAL;
     tmp1= &tmp;
@@ -3320,83 +3049,6 @@
 }
 
 
-/*
-  Fill and store records into I_S.referential_constraints table
-
-  SYNOPSIS
-    RefConstraintsISMethods::processTable()
-    session                 thread handle
-    tables              table list struct(processed table)
-    table               I_S table
-    res                 1 means the error during opening of the processed table
-                        0 means processed table is opened without error
-    base_name           db name
-    file_name           table name
-
-  RETURN
-    0	ok
-    #   error
-*/
-
-int
-RefConstraintsISMethods::processTable(Session *session, TableList *tables,
-                                      Table *table, bool res,
-                                      LEX_STRING *db_name, LEX_STRING *table_name)
-  const
-{
-  const CHARSET_INFO * const cs= system_charset_info;
-
-  if (res)
-  {
-    if (session->is_error())
-      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                   session->main_da.sql_errno(), session->main_da.message());
-    session->clear_error();
-    return(0);
-  }
-
-  {
-    List<FOREIGN_KEY_INFO> f_key_list;
-    Table *show_table= tables->table;
-    show_table->file->info(HA_STATUS_VARIABLE |
-                           HA_STATUS_NO_LOCK |
-                           HA_STATUS_TIME);
-
-    show_table->file->get_foreign_key_list(session, &f_key_list);
-    FOREIGN_KEY_INFO *f_key_info;
-    List_iterator_fast<FOREIGN_KEY_INFO> it(f_key_list);
-    while ((f_key_info= it++))
-    {
-      table->restoreRecordAsDefault();
-      table->field[1]->store(db_name->str, db_name->length, cs);
-      table->field[9]->store(table_name->str, table_name->length, cs);
-      table->field[2]->store(f_key_info->forein_id->str,
-                             f_key_info->forein_id->length, cs);
-      table->field[4]->store(f_key_info->referenced_db->str,
-                             f_key_info->referenced_db->length, cs);
-      table->field[10]->store(f_key_info->referenced_table->str,
-                             f_key_info->referenced_table->length, cs);
-      if (f_key_info->referenced_key_name)
-      {
-        table->field[5]->store(f_key_info->referenced_key_name->str,
-                               f_key_info->referenced_key_name->length, cs);
-        table->field[5]->set_notnull();
-      }
-      else
-        table->field[5]->set_null();
-      table->field[6]->store(STRING_WITH_LEN("NONE"), cs);
-      table->field[7]->store(f_key_info->update_method->str,
-                             f_key_info->update_method->length, cs);
-      table->field[8]->store(f_key_info->delete_method->str,
-                             f_key_info->delete_method->length, cs);
-      if (schema_table_store_record(session, table))
-        return(1);
-    }
-  }
-  return(0);
-}
-
-
 class FindSchemaTableByName : public unary_function<InfoSchemaTable *, bool>
 {
   const char *table_name;
@@ -3445,12 +3097,6 @@
 }
 
 
-InfoSchemaTable *get_schema_table(enum enum_schema_tables schema_table_idx)
-{
-  return &schema_tables[schema_table_idx];
-}
-
-
 Table *InfoSchemaMethods::createSchemaTable(Session *session, TableList *table_list)
   const
 {
@@ -3744,16 +3390,16 @@
     make_schema_select()
     session                  thread handler
     sel                  pointer to Select_Lex
-    schema_table_idx     index of 'schema_tables' element
+    schema_table_name    name of 'schema_tables' element
 
   RETURN
     true on error
 */
 
 bool make_schema_select(Session *session, Select_Lex *sel,
-                        enum enum_schema_tables schema_table_idx)
+                        const string& schema_table_name)
 {
-  InfoSchemaTable *schema_table= get_schema_table(schema_table_idx);
+  InfoSchemaTable *schema_table= find_schema_table(schema_table_name.c_str());
   LEX_STRING db, table;
   /*
      We have to make non const db_name & table_name
@@ -4010,46 +3656,6 @@
 };
 
 
-ColumnInfo table_constraints_fields_info[]=
-{
-  ColumnInfo("CONSTRAINT_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_TYPE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, 
-   "", OPEN_FULL_TABLE),
-  ColumnInfo()
-};
-
-
-ColumnInfo key_column_usage_fields_info[]=
-{
-  ColumnInfo("CONSTRAINT_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-  "", OPEN_FULL_TABLE),
-  ColumnInfo("COLUMN_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("ORDINAL_POSITION", 10 ,DRIZZLE_TYPE_LONGLONG, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("POSITION_IN_UNIQUE_CONSTRAINT", 10 ,DRIZZLE_TYPE_LONGLONG, 0, 1,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("REFERENCED_TABLE_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 1,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("REFERENCED_TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 1,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("REFERENCED_COLUMN_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 1,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo()
-};
-
-
 ColumnInfo table_names_fields_info[]=
 {
   ColumnInfo("TABLE_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", SKIP_OPEN_TABLE),
@@ -4082,51 +3688,13 @@
 };
 
 
-ColumnInfo plugin_fields_info[]=
-{
-  ColumnInfo("PLUGIN_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "Name",
-   SKIP_OPEN_TABLE),
-  ColumnInfo("PLUGIN_VERSION", 20, DRIZZLE_TYPE_VARCHAR, 0, 0, "", SKIP_OPEN_TABLE),
-  ColumnInfo("PLUGIN_STATUS", 10, DRIZZLE_TYPE_VARCHAR, 0, 0, "Status", SKIP_OPEN_TABLE),
-  ColumnInfo("PLUGIN_AUTHOR", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", SKIP_OPEN_TABLE),
-  ColumnInfo("PLUGIN_DESCRIPTION", 65535, DRIZZLE_TYPE_VARCHAR, 0, 1, "", SKIP_OPEN_TABLE),
-  ColumnInfo("PLUGIN_LICENSE", 80, DRIZZLE_TYPE_VARCHAR, 0, 1, "License", SKIP_OPEN_TABLE),
-  ColumnInfo()
-};
-
-ColumnInfo referential_constraints_fields_info[]=
-{
-  ColumnInfo("CONSTRAINT_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1, "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("CONSTRAINT_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("UNIQUE_CONSTRAINT_CATALOG", FN_REFLEN, DRIZZLE_TYPE_VARCHAR, 0, 1,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("UNIQUE_CONSTRAINT_SCHEMA", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo("UNIQUE_CONSTRAINT_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0,
-   MY_I_S_MAYBE_NULL, "", OPEN_FULL_TABLE),
-  ColumnInfo("MATCH_OPTION", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("UPDATE_RULE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("DELETE_RULE", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0, "", OPEN_FULL_TABLE),
-  ColumnInfo("REFERENCED_TABLE_NAME", NAME_CHAR_LEN, DRIZZLE_TYPE_VARCHAR, 0, 0,
-   "", OPEN_FULL_TABLE),
-  ColumnInfo()
-};
-
 static ColumnsISMethods columns_methods;
 static StatusISMethods status_methods;
 static VariablesISMethods variables_methods;
-static KeyColUsageISMethods key_col_usage_methods;
 static OpenTablesISMethods open_tables_methods;
-static PluginsISMethods plugins_methods;
-static RefConstraintsISMethods ref_constraints_methods;
 static SchemataISMethods schemata_methods;
 static StatsISMethods stats_methods;
 static TablesISMethods tables_methods;
-static TabConstraintsISMethods tab_constraints_methods;
 static TabNamesISMethods tab_names_methods;
 
 static InfoSchemaTable columns_table("COLUMNS",
@@ -4141,22 +3709,10 @@
                                         variables_fields_info,
                                         -1, -1, false, false, 0,
                                         &variables_methods);
-static InfoSchemaTable key_col_usage_table("KEY_COLUMN_USAGE",
-                                           key_column_usage_fields_info,
-                                           4, 5, false, true, OPEN_TABLE_ONLY,
-                                           &key_col_usage_methods);
 static InfoSchemaTable open_tab_table("OPEN_TABLES",
                                       open_tables_fields_info,
                                       -1, -1, true, false, 0,
                                       &open_tables_methods);
-static InfoSchemaTable plugins_table("PLUGINS",
-                                     plugin_fields_info,
-                                     -1, -1, false, false, 0,
-                                     &plugins_methods);
-static InfoSchemaTable ref_constrain_table("REFERENTIAL_CONSTRAINTS",
-                                           referential_constraints_fields_info,
-                                           1, 9, false, true, OPEN_TABLE_ONLY,
-                                           &ref_constraints_methods);
 static InfoSchemaTable schemata_table("SCHEMATA",
                                       schema_fields_info,
                                       1, -1, false, false, 0,
@@ -4182,10 +3738,6 @@
                                     tables_fields_info,
                                     1, 2, false, true, OPTIMIZE_I_S_TABLE,
                                     &tables_methods);
-static InfoSchemaTable tab_constrain_table("TABLE_CONSTRAINTS",
-                                           table_constraints_fields_info,
-                                           3, 4, false, true, OPEN_TABLE_ONLY,
-                                           &tab_constraints_methods);
 static InfoSchemaTable tab_names_table("TABLE_NAMES",
                                        table_names_fields_info,
                                        1, 2, true, true, 0,
@@ -4195,27 +3747,18 @@
                                  -1, -1, true, false, 0,
                                  &variables_methods);
 
-/**
- * @note
- *   Make sure that the order of schema_tables and enum_schema_tables are the same.
- */
-
 InfoSchemaTable schema_tables[]=
 {
   columns_table,
   global_stat_table,
   global_var_table,
-  key_col_usage_table,
   open_tab_table,
-  plugins_table,
-  ref_constrain_table,
   schemata_table,
   sess_stat_table,
   sess_var_table,
   stats_table,
   status_table,
   tables_table,
-  tab_constrain_table,
   tab_names_table,
   var_table,
   InfoSchemaTable()

=== modified file 'drizzled/show.h'
--- drizzled/show.h	2009-06-21 22:22:05 +0000
+++ drizzled/show.h	2009-06-29 17:24:02 +0000
@@ -62,12 +62,10 @@
                       const char *str,const char *wildstr);
 
 InfoSchemaTable *find_schema_table(const char* table_name);
-InfoSchemaTable *get_schema_table(enum enum_schema_tables schema_table_idx);
 bool make_schema_select(Session *session,  Select_Lex *sel,
-                       enum enum_schema_tables schema_table_idx);
+                        const std::string& schema_table_name);
 bool mysql_schema_table(Session *session, LEX *lex, TableList *table_list);
 bool get_schema_tables_result(JOIN *join, enum enum_schema_table_state executed_place);
-enum enum_schema_tables get_schema_table_idx(InfoSchemaTable *schema_table);
 
 bool mysqld_show_open_tables(Session *session,const char *wild);
 bool mysqld_show_logs(Session *session);

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-06-27 18:59:16 +0000
+++ drizzled/sql_parse.cc	2009-06-29 17:24:02 +0000
@@ -317,11 +317,11 @@
     It prepares a Select_Lex and a TableList object to represent the
     given command as a SELECT parse tree.
 
-  @param session              thread handle
-  @param lex              current lex
-  @param table_ident      table alias if it's used
-  @param schema_table_idx the type of the INFORMATION_SCHEMA table to be
-                          created
+  @param session           thread handle
+  @param lex               current lex
+  @param table_ident       table alias if it's used
+  @param schema_table_name the name of the INFORMATION_SCHEMA table to be
+                           created
 
   @note
     Due to the way this function works with memory and LEX it cannot
@@ -336,37 +336,34 @@
 */
 
 int prepare_schema_table(Session *session, LEX *lex, Table_ident *table_ident,
-                         enum enum_schema_tables schema_table_idx)
+                         const string& schema_table_name)
 {
   Select_Lex *schema_select_lex= NULL;
 
-  switch (schema_table_idx) {
-  case SCH_SCHEMATA:
-    break;
-  case SCH_TABLE_NAMES:
-  case SCH_TABLES:
-    {
-      LEX_STRING db;
-      size_t dummy;
-      if (lex->select_lex.db == NULL &&
-          lex->copy_db_to(&lex->select_lex.db, &dummy))
-      {
-        return(1);
-      }
-      schema_select_lex= new Select_Lex();
-      db.str= schema_select_lex->db= lex->select_lex.db;
-      schema_select_lex->table_list.first= NULL;
-      db.length= strlen(db.str);
-
-      if (check_db_name(&db))
-      {
-        my_error(ER_WRONG_DB_NAME, MYF(0), db.str);
-        return(1);
-      }
-      break;
-    }
-  case SCH_COLUMNS:
-  case SCH_STATISTICS:
+
+  if (schema_table_name.compare("TABLES") == 0 ||
+      schema_table_name.compare("TABLE_NAMES") == 0)
+  {
+    LEX_STRING db;
+    size_t dummy;
+    if (lex->select_lex.db == NULL &&
+        lex->copy_db_to(&lex->select_lex.db, &dummy))
+    {
+      return (1);
+    }
+    schema_select_lex= new Select_Lex();
+    db.str= schema_select_lex->db= lex->select_lex.db;
+    schema_select_lex->table_list.first= NULL;
+    db.length= strlen(db.str);
+
+    if (check_db_name(&db))
+    {
+      my_error(ER_WRONG_DB_NAME, MYF(0), db.str);
+      return (1);
+    }
+  }
+  else if (schema_table_name.compare("COLUMNS") == 0 ||
+           schema_table_name.compare("STATISTICS") == 0)
   {
     assert(table_ident);
     TableList **query_tables_last= lex->query_tables_last;
@@ -374,23 +371,16 @@
     /* 'parent_lex' is used in init_query() so it must be before it. */
     schema_select_lex->parent_lex= lex;
     schema_select_lex->init_query();
-    if (!schema_select_lex->add_table_to_list(session, table_ident, 0, 0, TL_READ))
-      return(1);
+    if (! schema_select_lex->add_table_to_list(session, table_ident, 0, 0, TL_READ))
+    {
+      return (1);
+    }
     lex->query_tables_last= query_tables_last;
-    break;
-  }
-  case SCH_OPEN_TABLES:
-  case SCH_VARIABLES:
-  case SCH_STATUS:
-  case SCH_TABLE_CONSTRAINTS:
-  case SCH_KEY_COLUMN_USAGE:
-  default:
-    break;
   }
 
   Select_Lex *select_lex= lex->current_select;
   assert(select_lex);
-  if (make_schema_select(session, select_lex, schema_table_idx))
+  if (make_schema_select(session, select_lex, schema_table_name))
   {
     return(1);
   }

=== modified file 'drizzled/sql_parse.h'
--- drizzled/sql_parse.h	2009-05-30 22:30:05 +0000
+++ drizzled/sql_parse.h	2009-06-29 17:24:02 +0000
@@ -93,7 +93,7 @@
 bool mysql_new_select(LEX *lex, bool move_down);
 
 int prepare_schema_table(Session *session, LEX *lex, Table_ident *table_ident,
-                         enum enum_schema_tables schema_table_idx);
+                         const std::string& schema_table_name);
 
 Item * all_any_subquery_creator(Item *left_expr,
                                 chooser_compare_func_creator cmp,

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2009-06-18 08:42:07 +0000
+++ drizzled/sql_yacc.yy	2009-06-29 17:24:02 +0000
@@ -4759,7 +4759,7 @@
            {
              LEX *lex= Lex;
              lex->sql_command= SQLCOM_SHOW_DATABASES;
-             if (prepare_schema_table(YYSession, lex, 0, SCH_SCHEMATA))
+             if (prepare_schema_table(YYSession, lex, 0, "SCHEMATA"))
                DRIZZLE_YYABORT;
            }
          | opt_full TABLES opt_db show_wild
@@ -4767,7 +4767,7 @@
              LEX *lex= Lex;
              lex->sql_command= SQLCOM_SHOW_TABLES;
              lex->select_lex.db= $3;
-             if (prepare_schema_table(YYSession, lex, 0, SCH_TABLE_NAMES))
+             if (prepare_schema_table(YYSession, lex, 0, "TABLE_NAMES"))
                DRIZZLE_YYABORT;
            }
          | TABLE_SYM STATUS_SYM opt_db show_wild
@@ -4775,7 +4775,7 @@
              LEX *lex= Lex;
              lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
              lex->select_lex.db= $3;
-             if (prepare_schema_table(YYSession, lex, 0, SCH_TABLES))
+             if (prepare_schema_table(YYSession, lex, 0, "TABLES"))
                DRIZZLE_YYABORT;
            }
         | OPEN_SYM TABLES opt_db show_wild
@@ -4783,7 +4783,7 @@
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
             lex->select_lex.db= $3;
-            if (prepare_schema_table(YYSession, lex, 0, SCH_OPEN_TABLES))
+            if (prepare_schema_table(YYSession, lex, 0, "OPEN_TABLES"))
               DRIZZLE_YYABORT;
           }
         | ENGINE_SYM known_storage_engines STATUS_SYM /* This should either go... well it should go */
@@ -4797,7 +4797,7 @@
             lex->sql_command= SQLCOM_SHOW_FIELDS;
             if ($5)
               $4->change_db($5);
-            if (prepare_schema_table(YYSession, lex, $4, SCH_COLUMNS))
+            if (prepare_schema_table(YYSession, lex, $4, "COLUMNS"))
               DRIZZLE_YYABORT;
           }
         | keys_or_index from_or_in table_ident opt_db where_clause
@@ -4806,7 +4806,7 @@
             lex->sql_command= SQLCOM_SHOW_KEYS;
             if ($4)
               $3->change_db($4);
-            if (prepare_schema_table(YYSession, lex, $3, SCH_STATISTICS))
+            if (prepare_schema_table(YYSession, lex, $3, "STATISTICS"))
               DRIZZLE_YYABORT;
           }
         | COUNT_SYM '(' '*' ')' WARNINGS
@@ -4822,7 +4822,7 @@
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_STATUS;
             lex->option_type= $1;
-            if (prepare_schema_table(YYSession, lex, 0, SCH_STATUS))
+            if (prepare_schema_table(YYSession, lex, 0, "STATUS"))
               DRIZZLE_YYABORT;
           }
         | opt_full PROCESSLIST_SYM
@@ -4832,7 +4832,7 @@
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_VARIABLES;
             lex->option_type= $1;
-            if (prepare_schema_table(YYSession, lex, 0, SCH_VARIABLES))
+            if (prepare_schema_table(YYSession, lex, 0, "VARIABLES"))
               DRIZZLE_YYABORT;
           }
         | CREATE DATABASE opt_if_not_exists ident
@@ -4892,7 +4892,7 @@
             lex->sql_command= SQLCOM_SHOW_FIELDS;
             lex->select_lex.db= 0;
             lex->verbose= 0;
-            if (prepare_schema_table(YYSession, lex, $2, SCH_COLUMNS))
+            if (prepare_schema_table(YYSession, lex, $2, "COLUMNS"))
               DRIZZLE_YYABORT;
           }
           opt_describe_column {}

=== modified file 'plugin/info_schema/info_schema.cc'
--- plugin/info_schema/info_schema.cc	2009-06-27 18:59:16 +0000
+++ plugin/info_schema/info_schema.cc	2009-06-29 16:05:47 +0000
@@ -38,7 +38,11 @@
 static vector<const ColumnInfo *> char_set_columns;
 static vector<const ColumnInfo *> collation_columns;
 static vector<const ColumnInfo *> coll_char_columns;
+static vector<const ColumnInfo *> key_col_usage_columns;
+static vector<const ColumnInfo *> plugin_columns;
 static vector<const ColumnInfo *> processlist_columns;
+static vector<const ColumnInfo *> ref_constraint_columns;
+static vector<const ColumnInfo *> tab_constraints_columns;
 
 /*
  * Methods for various I_S tables.
@@ -46,7 +50,11 @@
 static InfoSchemaMethods *char_set_methods= NULL;
 static InfoSchemaMethods *collation_methods= NULL;
 static InfoSchemaMethods *coll_char_methods= NULL;
+static InfoSchemaMethods *key_col_usage_methods= NULL;
+static InfoSchemaMethods *plugins_methods= NULL;
 static InfoSchemaMethods *processlist_methods= NULL;
+static InfoSchemaMethods *ref_constraint_methods= NULL;
+static InfoSchemaMethods *tab_constraints_methods= NULL;
 
 /*
  * I_S tables.
@@ -54,7 +62,11 @@
 static InfoSchemaTable *char_set_table= NULL;
 static InfoSchemaTable *collation_table= NULL;
 static InfoSchemaTable *coll_char_set_table= NULL;
+static InfoSchemaTable *key_col_usage_table= NULL;
+static InfoSchemaTable *plugins_table= NULL;
 static InfoSchemaTable *processlist_table= NULL;
+static InfoSchemaTable *ref_constraint_table= NULL;
+static InfoSchemaTable *tab_constraints_table= NULL;
 
 /**
  * Populate the vectors of columns for each I_S table.
@@ -80,11 +92,31 @@
     return true;
   }
 
+  if ((retval= createKeyColUsageColumns(key_col_usage_columns)) == true)
+  {
+    return true;
+  }
+
+  if ((retval= createPluginsColumns(plugin_columns)) == true)
+  {
+    return true;
+  }
+
   if ((retval= createProcessListColumns(processlist_columns)) == true)
   {
     return true;
   }
 
+  if ((retval= createRefConstraintColumns(ref_constraint_columns)) == true)
+  {
+    return true;
+  }
+
+  if ((retval= createTabConstraintsColumns(tab_constraints_columns)) == true)
+  {
+    return true;
+  }
+
   return false;
 }
 
@@ -96,7 +128,11 @@
   clearColumns(char_set_columns);
   clearColumns(collation_columns);
   clearColumns(coll_char_columns);
+  clearColumns(key_col_usage_columns);
+  clearColumns(plugin_columns);
   clearColumns(processlist_columns);
+  clearColumns(ref_constraint_columns);
+  clearColumns(tab_constraints_columns);
 }
 
 /**
@@ -121,11 +157,31 @@
     return true;
   }
 
+  if ((key_col_usage_methods= new(std::nothrow) KeyColUsageISMethods()) == NULL)
+  {
+    return true;
+  }
+
+  if ((plugins_methods= new(std::nothrow) PluginsISMethods()) == NULL)
+  {
+    return true;
+  }
+
   if ((processlist_methods= new(std::nothrow) ProcessListISMethods()) == NULL)
   {
     return true;
   }
 
+  if ((ref_constraint_methods= new(std::nothrow) RefConstraintsISMethods()) == NULL)
+  {
+    return true;
+  }
+
+  if ((tab_constraints_methods= new(std::nothrow) TabConstraintsISMethods()) == NULL)
+  {
+    return true;
+  }
+
   return false;
 }
 
@@ -137,7 +193,11 @@
   delete char_set_methods;
   delete collation_methods;
   delete coll_char_methods;
+  delete key_col_usage_methods;
+  delete plugins_methods;
   delete processlist_methods;
+  delete ref_constraint_methods;
+  delete tab_constraints_methods;
 }
 
 /**
@@ -175,6 +235,25 @@
     return true;
   }
 
+  key_col_usage_table= new(std::nothrow) InfoSchemaTable("KEY_COLUMN_USAGE",
+                                                         key_col_usage_columns,
+                                                         4, 5, false, true,
+                                                         OPEN_TABLE_ONLY,
+                                                         key_col_usage_methods);
+  if (key_col_usage_table == NULL)
+  {
+    return true;
+  }
+
+  plugins_table= new(std::nothrow) InfoSchemaTable("PLUGINS",
+                                                   plugin_columns,
+                                                   -1, -1, false, false, 0,
+                                                   plugins_methods);
+  if (plugins_table == NULL)
+  {
+    return true;
+  }
+
   processlist_table= new(std::nothrow) InfoSchemaTable("PROCESSLIST",
                                                        processlist_columns,
                                                        -1, -1, false, false, 0,
@@ -184,6 +263,26 @@
     return true;
   }
 
+  ref_constraint_table= new(std::nothrow) InfoSchemaTable("REFERENTIAL_CONSTRAINTS",
+                                                          ref_constraint_columns,
+                                                          1, 9, false, true,
+                                                          OPEN_TABLE_ONLY,
+                                                          ref_constraint_methods);
+  if (ref_constraint_table == NULL)
+  {
+    return true;
+  }
+
+  tab_constraints_table= new(std::nothrow) InfoSchemaTable("TABLE_CONSTRAINTS",
+                                                           tab_constraints_columns,
+                                                           3, 4, false, true,
+                                                           OPEN_TABLE_ONLY,
+                                                           tab_constraints_methods);
+  if (tab_constraints_table == NULL)
+  {
+    return true;
+  }
+
   return false;
 }
 
@@ -195,7 +294,11 @@
   delete char_set_table;
   delete collation_table;
   delete coll_char_set_table;
+  delete key_col_usage_table;
+  delete plugins_table;
   delete processlist_table;
+  delete ref_constraint_table;
+  delete tab_constraints_table;
 }
 
 /**
@@ -226,7 +329,11 @@
   registry.add(char_set_table);
   registry.add(collation_table);
   registry.add(coll_char_set_table);
+  registry.add(key_col_usage_table);
+  registry.add(plugins_table);
   registry.add(processlist_table);
+  registry.add(ref_constraint_table);
+  registry.add(tab_constraints_table);
 
   return 0;
 }
@@ -242,7 +349,11 @@
   registry.remove(char_set_table);
   registry.remove(collation_table);
   registry.remove(coll_char_set_table);
+  registry.remove(key_col_usage_table);
+  registry.remove(plugins_table);
   registry.remove(processlist_table);
+  registry.remove(ref_constraint_table);
+  registry.remove(tab_constraints_table);
 
   cleanupTableMethods();
   cleanupTableColumns();

=== modified file 'plugin/info_schema/info_schema_columns.cc'
--- plugin/info_schema/info_schema_columns.cc	2009-06-28 05:52:06 +0000
+++ plugin/info_schema/info_schema_columns.cc	2009-06-29 16:05:47 +0000
@@ -239,7 +239,250 @@
   return false;
 }
 
-
+bool createKeyColUsageColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *cat= new(std::nothrow) ColumnInfo("CONSTRAINT_CATALOG",
+                                                      FN_REFLEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      OPEN_FULL_TABLE);
+  if (cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch= new(std::nothrow) ColumnInfo("CONSTRAINT_SCHEMA",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      OPEN_FULL_TABLE);
+  if (sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("CONSTRAINT_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "",
+                                                       OPEN_FULL_TABLE);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_cat= new(std::nothrow) ColumnInfo("TABLE_CATALOG",
+                                                          FN_REFLEN,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          1,
+                                                          "",
+                                                          OPEN_FULL_TABLE);
+  if (tab_cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_sch= new(std::nothrow) ColumnInfo("TABLE_SCHEMA",
+                                                          NAME_CHAR_LEN,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          0,
+                                                          "",
+                                                          OPEN_FULL_TABLE);
+  if (tab_sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (tab_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *col_name= new(std::nothrow) ColumnInfo("COLUMN_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (col_name == NULL)
+  {
+    return true;
+  }
+  const ColumnInfo *ord_pos= new(std::nothrow) ColumnInfo("ORDINAL_POSITION",
+                                                          10,
+                                                          DRIZZLE_TYPE_LONGLONG,
+                                                          0,
+                                                          0,
+                                                          "",
+                                                          OPEN_FULL_TABLE);
+  if (ord_pos == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *pos_in_uniq= new(std::nothrow) ColumnInfo("POSITION_IN_UNIQUE_CONSTRAINT",
+                                                              10,
+                                                              DRIZZLE_TYPE_LONGLONG,
+                                                              0,
+                                                              1,
+                                                              "",
+                                                              OPEN_FULL_TABLE);
+  if (pos_in_uniq == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *ref_tab_sch= new(std::nothrow) ColumnInfo("REFERENCED_TABLE_SCHEMA",
+                                                              NAME_CHAR_LEN,
+                                                              DRIZZLE_TYPE_VARCHAR,
+                                                              0,
+                                                              1,
+                                                              "",
+                                                              OPEN_FULL_TABLE);
+  if (ref_tab_sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *ref_tab_name= new(std::nothrow) ColumnInfo("REFERENCED_TABLE_NAME",
+                                                               NAME_CHAR_LEN,
+                                                               DRIZZLE_TYPE_VARCHAR,
+                                                               0,
+                                                               1,
+                                                               "",
+                                                               OPEN_FULL_TABLE);
+  if (ref_tab_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *ref_col_name= new(std::nothrow) ColumnInfo("REFERENCED_COLUMN_NAME",
+                                                               NAME_CHAR_LEN,
+                                                               DRIZZLE_TYPE_VARCHAR,
+                                                               0,
+                                                               1,
+                                                               "",
+                                                               OPEN_FULL_TABLE);
+  if (ref_col_name == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(cat);
+  cols.push_back(sch);
+  cols.push_back(name);
+  cols.push_back(tab_cat);
+  cols.push_back(tab_sch);
+  cols.push_back(tab_name);
+  cols.push_back(col_name);
+  cols.push_back(ord_pos);
+  cols.push_back(pos_in_uniq);
+  cols.push_back(ref_tab_sch);
+  cols.push_back(ref_tab_name);
+  cols.push_back(ref_col_name);
+
+  return false;
+}
+
+bool createPluginsColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("PLUGIN_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Name",
+                                                       SKIP_OPEN_TABLE);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *ver= new(std::nothrow) ColumnInfo("PLUGIN_VERSION",
+                                                      20,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      SKIP_OPEN_TABLE);
+  if (ver == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *stat= new(std::nothrow) ColumnInfo("PLUGIN_STATUS",
+                                                       10,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "Status",
+                                                       SKIP_OPEN_TABLE);
+  if (stat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *aut= new(std::nothrow) ColumnInfo("PLUGIN_AUTHOR",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      SKIP_OPEN_TABLE);
+  if (aut == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *descrip= new(std::nothrow) ColumnInfo("PLUGIN_DESCRIPTION",
+                                                          65535,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          1,
+                                                          "",
+                                                          SKIP_OPEN_TABLE);
+  if (descrip == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *lic= new(std::nothrow) ColumnInfo("PLUGIN_LICENSE",
+                                                      80,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "License",
+                                                      SKIP_OPEN_TABLE);
+  if (lic == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(name);
+  cols.push_back(ver);
+  cols.push_back(stat);
+  cols.push_back(aut);
+  cols.push_back(descrip);
+  cols.push_back(lic);
+
+  return false;
+}
 
 bool createProcessListColumns(vector<const ColumnInfo *>& cols)
 {
@@ -357,6 +600,246 @@
   return false;
 }
 
+bool createRefConstraintColumns(vector<const ColumnInfo *>& cols)
+{
+  /*
+   * Create the columns for the table.
+   */
+  const ColumnInfo *cat= new(std::nothrow) ColumnInfo("CONSTRAINT_CATALOG",
+                                                      FN_REFLEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      OPEN_FULL_TABLE);
+
+  if (cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch= new(std::nothrow) ColumnInfo("CONSTRAINT_SCHEMA",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      OPEN_FULL_TABLE);
+  if (sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("CONSTRAINT_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "",
+                                                       OPEN_FULL_TABLE);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *uniq_cat= new(std::nothrow) ColumnInfo("UNIQUE_CONSTRAINT_CATALOG",
+                                                           FN_REFLEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           1,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (uniq_cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *uniq_sch= new(std::nothrow) ColumnInfo("UNIQUE_CONSTRAINT_SCHEMA",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (uniq_sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *uniq_name= new(std::nothrow) ColumnInfo("UNIQUE_CONSTRAINT_NAME",
+                                                            NAME_CHAR_LEN,
+                                                            DRIZZLE_TYPE_VARCHAR,
+                                                            0,
+                                                            MY_I_S_MAYBE_NULL,
+                                                            "",
+                                                            OPEN_FULL_TABLE);
+  if (uniq_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *match= new(std::nothrow) ColumnInfo("MATCH_OPTION",
+                                                        NAME_CHAR_LEN,
+                                                        DRIZZLE_TYPE_VARCHAR,
+                                                        0,
+                                                        0,
+                                                        "",
+                                                        OPEN_FULL_TABLE);
+  if (match == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *update= new(std::nothrow) ColumnInfo("UPDATE_RULE",
+                                                         NAME_CHAR_LEN,
+                                                         DRIZZLE_TYPE_VARCHAR,
+                                                         0,
+                                                         0,
+                                                         "",
+                                                         OPEN_FULL_TABLE);
+  if (update == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *del_rule= new(std::nothrow) ColumnInfo("DELETE_RULE",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (del_rule == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (tab_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *ref_name= new(std::nothrow) ColumnInfo("REFERENCED_TABLE_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (ref_name == NULL)
+  {
+    return true;
+  }
+
+  /*
+   * Add the columns to the vector.
+   */
+  cols.push_back(cat);
+  cols.push_back(sch);
+  cols.push_back(name);
+  cols.push_back(uniq_cat);
+  cols.push_back(uniq_sch);
+  cols.push_back(uniq_name);
+  cols.push_back(match);
+  cols.push_back(update);
+  cols.push_back(del_rule);
+  cols.push_back(tab_name);
+  cols.push_back(ref_name);
+
+  return false;
+}
+
+bool createTabConstraintsColumns(vector<const ColumnInfo *>& cols)
+{
+  const ColumnInfo *cat= new(std::nothrow) ColumnInfo("CONSTRAINT_CATALOG",
+                                                      FN_REFLEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      1,
+                                                      "",
+                                                      OPEN_FULL_TABLE);
+  if (cat == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *sch= new(std::nothrow) ColumnInfo("CONSTRAINT_SCHEMA",
+                                                      NAME_CHAR_LEN,
+                                                      DRIZZLE_TYPE_VARCHAR,
+                                                      0,
+                                                      0,
+                                                      "",
+                                                      OPEN_FULL_TABLE);
+  if (sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *name= new(std::nothrow) ColumnInfo("CONSTRAINT_NAME",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "",
+                                                       OPEN_FULL_TABLE);
+  if (name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_sch= new(std::nothrow) ColumnInfo("TABLE_SCHEMA",
+                                                          NAME_CHAR_LEN,
+                                                          DRIZZLE_TYPE_VARCHAR,
+                                                          0,
+                                                          0,
+                                                          "",
+                                                          OPEN_FULL_TABLE);
+  if (tab_sch == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *tab_name= new(std::nothrow) ColumnInfo("TABLE_NAME",
+                                                           NAME_CHAR_LEN,
+                                                           DRIZZLE_TYPE_VARCHAR,
+                                                           0,
+                                                           0,
+                                                           "",
+                                                           OPEN_FULL_TABLE);
+  if (tab_name == NULL)
+  {
+    return true;
+  }
+
+  const ColumnInfo *type= new(std::nothrow) ColumnInfo("CONSTRAINT_TYPE",
+                                                       NAME_CHAR_LEN,
+                                                       DRIZZLE_TYPE_VARCHAR,
+                                                       0,
+                                                       0,
+                                                       "",
+                                                       OPEN_FULL_TABLE);
+  if (type == NULL)
+  {
+    return true;
+  }
+
+  cols.push_back(cat);
+  cols.push_back(sch);
+  cols.push_back(name);
+  cols.push_back(tab_sch);
+  cols.push_back(tab_name);
+  cols.push_back(type);
+
+  return false;
+}
+
 /*
  * Function object used for deleting the memory allocated
  * for the columns contained with the vector of columns.

=== modified file 'plugin/info_schema/info_schema_columns.h'
--- plugin/info_schema/info_schema_columns.h	2009-06-27 19:04:38 +0000
+++ plugin/info_schema/info_schema_columns.h	2009-06-29 16:05:47 +0000
@@ -52,6 +52,26 @@
 bool createCollCharSetColumns(std::vector<const ColumnInfo *>& cols);
 
 /**
+ * Create the various columns for the key column usage
+ * I_S table and add them to the std::vector of columns for the
+ * table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createKeyColUsageColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
+ * Create the various columns for the PLUGINS
+ * I_S table and add them to the std::vector of columns for the
+ * table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createPluginsColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Create the various volumns for the PROCESSLIST I_S table and add them
  * to the std::vector of columns for the PROCESSLIST table.
  *
@@ -61,6 +81,24 @@
 bool createProcessListColumns(std::vector<const ColumnInfo *>& cols);
 
 /**
+ * Create the various volumns for the REFERENTIAL_CONSTRAINTS I_S table 
+ * and add them to the std::vector of columns for this table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createRefConstraintColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
+ * Create the various volumns for the TABLE_CONSTRAINTS I_S table 
+ * and add them to the std::vector of columns for this table.
+ *
+ * @param[out] cols vector to add columns to
+ * @return false on success; true on failure
+ */
+bool createTabConstraintsColumns(std::vector<const ColumnInfo *>& cols);
+
+/**
  * Iterate through the given vector of columns and delete the memory that
  * has been allocated for them.
  *

=== modified file 'plugin/info_schema/info_schema_methods.cc'
--- plugin/info_schema/info_schema_methods.cc	2009-06-27 18:59:16 +0000
+++ plugin/info_schema/info_schema_methods.cc	2009-06-29 16:05:47 +0000
@@ -156,6 +156,208 @@
   return 0;
 }
 
+static void store_key_column_usage(Table *table, LEX_STRING *db_name,
+                                   LEX_STRING *table_name, const char *key_name,
+                                   uint32_t key_len, const char *con_type, uint32_t con_len,
+                                   int64_t idx)
+{
+  const CHARSET_INFO * const cs= system_charset_info;
+  table->field[1]->store(db_name->str, db_name->length, cs);
+  table->field[2]->store(key_name, key_len, cs);
+  table->field[4]->store(db_name->str, db_name->length, cs);
+  table->field[5]->store(table_name->str, table_name->length, cs);
+  table->field[6]->store(con_type, con_len, cs);
+  table->field[7]->store((int64_t) idx, true);
+}
+
+int KeyColUsageISMethods::processTable(Session *session,
+                                              TableList *tables,
+                                              Table *table, bool res,
+                                              LEX_STRING *db_name,
+                                              LEX_STRING *table_name) const
+{
+  if (res)
+  {
+    if (session->is_error())
+      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+                   session->main_da.sql_errno(), session->main_da.message());
+    session->clear_error();
+    return(0);
+  }
+  else
+  {
+    List<FOREIGN_KEY_INFO> f_key_list;
+    Table *show_table= tables->table;
+    KEY *key_info=show_table->key_info;
+    uint32_t primary_key= show_table->s->primary_key;
+    show_table->file->info(HA_STATUS_VARIABLE |
+                           HA_STATUS_NO_LOCK |
+                           HA_STATUS_TIME);
+    for (uint32_t i=0 ; i < show_table->s->keys ; i++, key_info++)
+    {
+      if (i != primary_key && !(key_info->flags & HA_NOSAME))
+      {
+        continue;
+      }
+      uint32_t f_idx= 0;
+      KEY_PART_INFO *key_part= key_info->key_part;
+      for (uint32_t j=0 ; j < key_info->key_parts ; j++,key_part++)
+      {
+        if (key_part->field)
+        {
+          f_idx++;
+          table->restoreRecordAsDefault();
+          store_key_column_usage(table, db_name, table_name,
+                                 key_info->name,
+                                 strlen(key_info->name),
+                                 key_part->field->field_name,
+                                 strlen(key_part->field->field_name),
+                                 (int64_t) f_idx);
+          if (schema_table_store_record(session, table))
+          {
+            return (1);
+          }
+        }
+      }
+    }
+
+    show_table->file->get_foreign_key_list(session, &f_key_list);
+    FOREIGN_KEY_INFO *f_key_info;
+    List_iterator_fast<FOREIGN_KEY_INFO> fkey_it(f_key_list);
+    while ((f_key_info= fkey_it++))
+    {
+      LEX_STRING *f_info;
+      LEX_STRING *r_info;
+      List_iterator_fast<LEX_STRING> it(f_key_info->foreign_fields),
+        it1(f_key_info->referenced_fields);
+      uint32_t f_idx= 0;
+      while ((f_info= it++))
+      {
+        r_info= it1++;
+        f_idx++;
+        table->restoreRecordAsDefault();
+        store_key_column_usage(table, db_name, table_name,
+                               f_key_info->forein_id->str,
+                               f_key_info->forein_id->length,
+                               f_info->str, f_info->length,
+                               (int64_t) f_idx);
+        table->field[8]->store((int64_t) f_idx, true);
+        table->field[8]->set_notnull();
+        table->field[9]->store(f_key_info->referenced_db->str,
+                               f_key_info->referenced_db->length,
+                               system_charset_info);
+        table->field[9]->set_notnull();
+        table->field[10]->store(f_key_info->referenced_table->str,
+                                f_key_info->referenced_table->length,
+                                system_charset_info);
+        table->field[10]->set_notnull();
+        table->field[11]->store(r_info->str, r_info->length,
+                                system_charset_info);
+        table->field[11]->set_notnull();
+        if (schema_table_store_record(session, table))
+        {
+          return (1);
+        }
+      }
+    }
+  }
+  return (res);
+}
+
+class ShowPlugins : public unary_function<st_plugin_int *, bool>
+{
+  Session *session;
+  Table *table;
+public:
+  ShowPlugins(Session *session_arg, Table *table_arg)
+    : session(session_arg), table(table_arg) {}
+
+  result_type operator() (argument_type plugin)
+  {
+    struct drizzled_plugin_manifest *plug= plugin_decl(plugin);
+    const CHARSET_INFO * const cs= system_charset_info;
+
+    table->restoreRecordAsDefault();
+
+    table->field[0]->store(plugin_name(plugin)->str,
+                           plugin_name(plugin)->length, cs);
+
+    if (plug->version)
+    {
+      table->field[1]->store(plug->version, strlen(plug->version), cs);
+      table->field[1]->set_notnull();
+    }
+    else
+      table->field[1]->set_null();
+
+    if (plugin->isInited)
+    {
+      table->field[2]->store(STRING_WITH_LEN("ACTIVE"), cs);
+    }
+    else
+    {
+      table->field[2]->store(STRING_WITH_LEN("INACTIVE"), cs);
+    }
+
+    if (plug->author)
+    {
+      table->field[3]->store(plug->author, strlen(plug->author), cs);
+      table->field[3]->set_notnull();
+    }
+    else
+    {
+      table->field[3]->set_null();
+    }
+
+    if (plug->descr)
+    {
+      table->field[4]->store(plug->descr, strlen(plug->descr), cs);
+      table->field[4]->set_notnull();
+    }
+    else
+    {
+      table->field[4]->set_null();
+    }
+
+    switch (plug->license) {
+    case PLUGIN_LICENSE_GPL:
+      table->field[5]->store(PLUGIN_LICENSE_GPL_STRING,
+                             strlen(PLUGIN_LICENSE_GPL_STRING), cs);
+      break;
+    case PLUGIN_LICENSE_BSD:
+      table->field[5]->store(PLUGIN_LICENSE_BSD_STRING,
+                             strlen(PLUGIN_LICENSE_BSD_STRING), cs);
+      break;
+    case PLUGIN_LICENSE_LGPL:
+      table->field[5]->store(PLUGIN_LICENSE_LGPL_STRING,
+                             strlen(PLUGIN_LICENSE_LGPL_STRING), cs);
+      break;
+    default:
+      table->field[5]->store(PLUGIN_LICENSE_PROPRIETARY_STRING,
+                             strlen(PLUGIN_LICENSE_PROPRIETARY_STRING), cs);
+      break;
+    }
+    table->field[5]->set_notnull();
+
+    return schema_table_store_record(session, table);
+  }
+};
+
+int PluginsISMethods::fillTable(Session *session, TableList *tables, COND *)
+{
+  Table *table= tables->table;
+
+  PluginRegistry &registry= PluginRegistry::getPluginRegistry();
+  vector<st_plugin_int *> plugins= registry.get_list(true);
+  vector<st_plugin_int *>::iterator iter=
+    find_if(plugins.begin(), plugins.end(), ShowPlugins(session, table));
+  if (iter != plugins.end())
+  {
+    return 1;
+  }
+  return (0);
+}
+
 int ProcessListISMethods::fillTable(Session* session, TableList* tables, COND*)
 {
   Table *table= tables->table;
@@ -247,3 +449,146 @@
   return(0);
 }
 
+int
+RefConstraintsISMethods::processTable(Session *session, TableList *tables,
+                                      Table *table, bool res,
+                                      LEX_STRING *db_name, LEX_STRING *table_name)
+  const
+{
+  const CHARSET_INFO * const cs= system_charset_info;
+
+  if (res)
+  {
+    if (session->is_error())
+      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+                   session->main_da.sql_errno(), session->main_da.message());
+    session->clear_error();
+    return(0);
+  }
+
+  {
+    List<FOREIGN_KEY_INFO> f_key_list;
+    Table *show_table= tables->table;
+    show_table->file->info(HA_STATUS_VARIABLE |
+                           HA_STATUS_NO_LOCK |
+                           HA_STATUS_TIME);
+
+    show_table->file->get_foreign_key_list(session, &f_key_list);
+    FOREIGN_KEY_INFO *f_key_info;
+    List_iterator_fast<FOREIGN_KEY_INFO> it(f_key_list);
+    while ((f_key_info= it++))
+    {
+      table->restoreRecordAsDefault();
+      table->field[1]->store(db_name->str, db_name->length, cs);
+      table->field[9]->store(table_name->str, table_name->length, cs);
+      table->field[2]->store(f_key_info->forein_id->str,
+                             f_key_info->forein_id->length, cs);
+      table->field[4]->store(f_key_info->referenced_db->str,
+                             f_key_info->referenced_db->length, cs);
+      table->field[10]->store(f_key_info->referenced_table->str,
+                             f_key_info->referenced_table->length, cs);
+      if (f_key_info->referenced_key_name)
+      {
+        table->field[5]->store(f_key_info->referenced_key_name->str,
+                               f_key_info->referenced_key_name->length, cs);
+        table->field[5]->set_notnull();
+      }
+      else
+      {
+        table->field[5]->set_null();
+      }
+      table->field[6]->store(STRING_WITH_LEN("NONE"), cs);
+      table->field[7]->store(f_key_info->update_method->str,
+                             f_key_info->update_method->length, cs);
+      table->field[8]->store(f_key_info->delete_method->str,
+                             f_key_info->delete_method->length, cs);
+      if (schema_table_store_record(session, table))
+      {
+        return (1);
+      }
+    }
+  }
+  return (0);
+}
+
+static bool store_constraints(Session *session, Table *table, LEX_STRING *db_name,
+                              LEX_STRING *table_name, const char *key_name,
+                              uint32_t key_len, const char *con_type, uint32_t con_len)
+{
+  const CHARSET_INFO * const cs= system_charset_info;
+  table->restoreRecordAsDefault();
+  table->field[1]->store(db_name->str, db_name->length, cs);
+  table->field[2]->store(key_name, key_len, cs);
+  table->field[3]->store(db_name->str, db_name->length, cs);
+  table->field[4]->store(table_name->str, table_name->length, cs);
+  table->field[5]->store(con_type, con_len, cs);
+  return schema_table_store_record(session, table);
+}
+
+int TabConstraintsISMethods::processTable(Session *session, TableList *tables,
+                                          Table *table, bool res,
+                                          LEX_STRING *db_name,
+                                          LEX_STRING *table_name) const
+{
+  if (res)
+  {
+    if (session->is_error())
+    {
+      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
+                   session->main_da.sql_errno(), session->main_da.message());
+    }
+    session->clear_error();
+    return (0);
+  }
+  else
+  {
+    List<FOREIGN_KEY_INFO> f_key_list;
+    Table *show_table= tables->table;
+    KEY *key_info=show_table->key_info;
+    uint32_t primary_key= show_table->s->primary_key;
+    show_table->file->info(HA_STATUS_VARIABLE |
+                           HA_STATUS_NO_LOCK |
+                           HA_STATUS_TIME);
+    for (uint32_t i=0 ; i < show_table->s->keys ; i++, key_info++)
+    {
+      if (i != primary_key && !(key_info->flags & HA_NOSAME))
+      {
+        continue;
+      }
+
+      if (i == primary_key && is_primary_key(key_info))
+      {
+        if (store_constraints(session, table, db_name, table_name, key_info->name,
+                              strlen(key_info->name),
+                              STRING_WITH_LEN("PRIMARY KEY")))
+        {
+          return (1);
+        }
+      }
+      else if (key_info->flags & HA_NOSAME)
+      {
+        if (store_constraints(session, table, db_name, table_name, key_info->name,
+                              strlen(key_info->name),
+                              STRING_WITH_LEN("UNIQUE")))
+        {
+          return (1);
+        }
+      }
+    }
+
+    show_table->file->get_foreign_key_list(session, &f_key_list);
+    FOREIGN_KEY_INFO *f_key_info;
+    List_iterator_fast<FOREIGN_KEY_INFO> it(f_key_list);
+    while ((f_key_info=it++))
+    {
+      if (store_constraints(session, table, db_name, table_name,
+                            f_key_info->forein_id->str,
+                            strlen(f_key_info->forein_id->str),
+                            "FOREIGN KEY", 11))
+      {
+        return (1);
+      }
+    }
+  }
+  return (res);
+}

=== modified file 'plugin/info_schema/info_schema_methods.h'
--- plugin/info_schema/info_schema_methods.h	2009-06-27 18:59:16 +0000
+++ plugin/info_schema/info_schema_methods.h	2009-06-29 16:05:47 +0000
@@ -72,6 +72,36 @@
 
 /**
  * @class
+ *   KeyColUsageISMethods
+ * @brief
+ *   Class which implements any methods that the key column usage
+ *   I_S table needs besides the default methods
+ */
+class KeyColUsageISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int processTable(Session *session, TableList *tables,
+                           Table *table, bool res, LEX_STRING *db_name,
+                           LEX_STRING *table_name) const;
+};
+
+/**
+ * @class
+ *   PluginsISMethods
+ * @brief
+ *   Class which implements any methods that the PLUGINS
+ *   I_S table needs besides the default methods
+ */
+class PluginsISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int fillTable(Session *session,
+                        TableList *tables,
+                        COND *cond);
+};
+
+/**
+ * @class
  *   ProcessListISMethods
  * @brief
  *   Class which implements any methods that the PROCESSLIST
@@ -85,4 +115,47 @@
                         COND *cond);
 };
 
+/**
+ * @class
+ *   RefConstraintISMethods
+ * @brief
+ *   Class which implements any methods that the REFERENTIAL_CONSTRAINTS
+ *   I_S table needs besides the default methods
+ */
+class RefConstraintsISMethods : public InfoSchemaMethods
+{
+public:
+  /**
+   * Fill and store records into I_S.referential_constraints table
+   *
+   * @param[in] session   thread handle
+   * @param[in] tables    table list struct(processed table)
+   * @param[in] table     I_S table
+   * @param[in] res       1 means the error during opening of the processed table
+   *                      0 means processed table is opened without error
+   * @param[in] base_name db name
+   * @param[in] file_name table name
+   *
+   * @return 0 on success; 1 on failure
+   */
+  virtual int processTable(Session *session, TableList *tables,
+                           Table *table, bool res, LEX_STRING *db_name,
+                           LEX_STRING *table_name) const;
+};
+
+/**
+ * @class
+ *   TabConstraintsISMethods
+ * @brief
+ *   Class which implements any methods that the TABLE_CONSTRAINTS
+ *   I_S table needs besides the default methods
+ */
+class TabConstraintsISMethods : public InfoSchemaMethods
+{
+public:
+  virtual int processTable(Session *session, TableList *tables,
+                           Table *table, bool res, LEX_STRING *db_name,
+                           LEX_STRING *table_name) const;
+};
+
 #endif /* DRIZZLE_INFO_SCHEMA_METHODS_H */

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2009-06-27 19:00:45 +0000
+++ tests/r/information_schema.result	2009-06-29 16:07:20 +0000
@@ -247,15 +247,11 @@
 COLUMNS	TABLE_SCHEMA
 GLOBAL_STATUS	VARIABLE_NAME
 GLOBAL_VARIABLES	VARIABLE_NAME
-KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
-PLUGINS	PLUGIN_NAME
-REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
 SCHEMATA	SCHEMA_NAME
 SESSION_STATUS	VARIABLE_NAME
 SESSION_VARIABLES	VARIABLE_NAME
 STATISTICS	TABLE_SCHEMA
 TABLES	TABLE_SCHEMA
-TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
 INNODB_TRX	trx_id
 INNODB_LOCKS	lock_id
 INNODB_LOCK_WAITS	requesting_trx_id
@@ -266,7 +262,11 @@
 CHARACTER_SETS	CHARACTER_SET_NAME
 COLLATIONS	COLLATION_NAME
 COLLATION_CHARACTER_SET_APPLICABILITY	COLLATION_NAME
+KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
+PLUGINS	PLUGIN_NAME
 PROCESSLIST	ID
+REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
+TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
 SELECT t.table_name, c1.column_name
 FROM information_schema.tables t
 INNER JOIN
@@ -286,15 +286,11 @@
 COLUMNS	TABLE_SCHEMA
 GLOBAL_STATUS	VARIABLE_NAME
 GLOBAL_VARIABLES	VARIABLE_NAME
-KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
-PLUGINS	PLUGIN_NAME
-REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
 SCHEMATA	SCHEMA_NAME
 SESSION_STATUS	VARIABLE_NAME
 SESSION_VARIABLES	VARIABLE_NAME
 STATISTICS	TABLE_SCHEMA
 TABLES	TABLE_SCHEMA
-TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
 INNODB_TRX	trx_id
 INNODB_LOCKS	lock_id
 INNODB_LOCK_WAITS	requesting_trx_id
@@ -305,7 +301,11 @@
 CHARACTER_SETS	CHARACTER_SET_NAME
 COLLATIONS	COLLATION_NAME
 COLLATION_CHARACTER_SET_APPLICABILITY	COLLATION_NAME
+KEY_COLUMN_USAGE	CONSTRAINT_SCHEMA
+PLUGINS	PLUGIN_NAME
 PROCESSLIST	ID
+REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA
+TABLE_CONSTRAINTS	CONSTRAINT_SCHEMA
 SELECT MAX(table_name) FROM information_schema.tables;
 MAX(table_name)
 TABLE_CONSTRAINTS
@@ -495,7 +495,7 @@
 utf8_hungarian_ci	utf8	242	0	Yes	8	0
 utf8_sinhala_ci	utf8	243	0	Yes	8	0
 binary	binary	63	0	Yes	1	0
-SELECT *
+SELECT * 
 FROM information_schema.collation_character_set_applicability;
 COLLATION_NAME	CHARACTER_SET_NAME
 utf8_general_ci	utf8
@@ -521,3 +521,12 @@
 utf8_hungarian_ci	utf8
 utf8_sinhala_ci	utf8
 binary	binary
+SELECT *
+FROM information_schema.key_column_usage;
+CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_CATALOG	TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	ORDINAL_POSITION	POSITION_IN_UNIQUE_CONSTRAINT	REFERENCED_TABLE_SCHEMA	REFERENCED_TABLE_NAME	REFERENCED_COLUMN_NAME
+SELECT * 
+FROM information_schema.referential_constraints;
+CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	UNIQUE_CONSTRAINT_CATALOG	UNIQUE_CONSTRAINT_SCHEMA	UNIQUE_CONSTRAINT_NAME	MATCH_OPTION	UPDATE_RULE	DELETE_RULE	TABLE_NAME	REFERENCED_TABLE_NAME
+SELECT *
+FROM information_schema.table_constraints;
+CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_SCHEMA	TABLE_NAME	CONSTRAINT_TYPE

=== modified file 'tests/t/information_schema.test'
--- tests/t/information_schema.test	2009-06-27 19:00:45 +0000
+++ tests/t/information_schema.test	2009-06-29 15:34:22 +0000
@@ -423,9 +423,27 @@
 #
 # perform a query on COLLATION_CHARACTER_SET_APPLICABILITY
 #
-SELECT *
+SELECT * 
 FROM information_schema.collation_character_set_applicability;
 
+#
+# perform a query on KEY_COLUMN_USAGE
+#
+SELECT *
+FROM information_schema.key_column_usage;
+
+#
+# perform a query on REFERENTIAL_CONSTRAINTS
+#
+SELECT * 
+FROM information_schema.referential_constraints;
+
+#
+# query TABLE_CONSTRAINTS table
+#
+SELECT *
+FROM information_schema.table_constraints;
+
 # 
 # do a query on the PLUGINS table in I_S to ensure it works correctly
 # how do we test for this if the contents of this table can change

